/****************************************************************
 test-essex.C
 william.majoros@duke.edu

 This is open-source software, governed by the ARTISTIC LICENSE 
 (see www.opensource.org).
 ****************************************************************/
#include <iostream>
#include "String.H"
#include "CommandLine.H"
#include "Essex.H"
using namespace std;
using namespace BOOM;


class Application
{
public:
  Application();
  int main(int argc,char *argv[]);
};


int main(int argc,char *argv[])
  {
    try
      {
	Application app;
	return app.main(argc,argv);
      }
    catch(const char *p)
      {
	cerr << p << endl;
      }
    catch(const string &msg)
      {
	cerr << msg.c_str() << endl;
      }
    catch(const exception &e)
      {
	cerr << "STL exception caught in main:\n" << e.what() << endl;
      }
    catch(...)
      {
	cerr << "Unknown exception caught in main" << endl;
      }
    return -1;
  }



Application::Application()
  {
    // ctor
  }



int Application::main(int argc,char *argv[])
{
  // Process command line
  CommandLine cmd(argc,argv,"");
  if(cmd.numArgs()!=1)
    throw String("test-essex <infile>");
  String infile=cmd.arg(0);
  Essex::Parser parser(infile);
  Essex::Query q("probe/LogFoldChange>10");
  while(1) {
    Essex::Node *elem=parser.nextElem();
    if(!elem) break;
    //cout<<"found an elem:\n";
    //cout<<*elem<<endl;

    Vector<Essex::Node*> &hits=*q.search(elem);
    int n=hits.size();
    for(int i=0 ; i<n ; ++i) {
      Essex::Node *hit=hits[i];
      cout<<*hit<<endl;
    }
    delete &hits;
  }
  return 0;
}

